<?PHP
class	AddressBook {
	var $dbname = "ismail";
	var $dbusername = "ismailuser";
	var $dbpassword = "ismailpass";
	var $dbhost = "localhost";
	var $dbport = "5432";
	var $conn;
	var $userid;

	function AddressBook() {
		$this->conn = pg_pconnect("dbname=$this->dbname user=$this->dbusername password=$this->dbpassword host=$this->dbhost port=$this->dbport");
		if ($this->conn === false) {
			trigger_error("Unable to connect to database", E_USER_ERROR);
		}
		// Check to make sure we have an entry in the database for this user
		$rs = $this->_Query("SELECT id FROM users WHERE username='" . addslashes($_SESSION["emailaddress"]) . "' LIMIT 1");
		if (pg_num_rows($rs) == 0) {
			$rs = $this->_Query("INSERT INTO users (username) VALUES ('" . addslashes($_SESSION["emailaddress"]) . "')");
			if ($rs === false) {
				trigger_error("Unable to add user to database", E_USER_ERROR);
			}
			$rs = $this->_Query("SELECT currval('users_id_seq') AS id");
		}
		$rs = pg_fetch_array($rs);
		$this->userid = (int)$rs["id"];
	}

	// Returns hash of id/name pairs of entries
	function GetEntries() {
		$rs = $this->_Query("SELECT id FROM entries WHERE userid=" . $this->userid);
		$arr = array();
		for ($i = 0; $i < pg_num_rows($rs); $i++) {
			$row = pg_fetch_array($rs);
			$info = $this->GetEntryInfo($row["id"]);
			$arr[$row["id"]] = $info["name"];
		}
		asort($arr);
		$entries = array();
		$counter = 0;
		while (list($id, $name) = each($arr)) {
			$entries[$counter]["id"] = $id;
			$entries[$counter]["name"] = $name;
			$counter++;
		}
		return $entries;
	}

	// Takes a unique id of the entry and returns an associative array of information regarding it.
	// first, middle, last, nickname, default email (default), formatted name (nam), emails (which is an integer indexed array of email addresses)
	function GetEntryInfo($entryid) {
		$rs = $this->_Query("SELECT * FROM entries WHERE id=" . (int)$entryid . " AND userid=" . $this->userid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		} else {
			$rs = pg_fetch_array($rs);
		}
		$entry["id"] = $rs["id"];
		$entry["first"] = $rs["first"];
		$entry["middle"] = $rs["middle"];
		$entry["last"] = $rs["last"];
		$entry["nickname"] = $rs["nickname"];
		$rs = $this->_Query("SELECT * FROM emails WHERE entryid=" . (int)$entry["id"]);
		for ($i = 0; $i < pg_num_rows($rs); $i++) {
			$row = pg_fetch_array($rs);
			$entry["emails"][$i] = $row["email"];
			if ($row["isdefault"] == 't') {
				$entry["default"] = $row["email"];
			}
		}
		// Now set the name to show up in the listings
		if ($entry["nickname"]) {
			$entry["name"] = $entry["nickname"];
		}
		if ($entry["name"] == "") {
			// Get a name if there is one
			$str = $entry["last"];
			if (($str != "") && (($entry["first"] != "") || ($entry["middle"] != ""))){
				$str .= ", ";
			}
			$str .= trim($entry["first"] . " " . $entry["middle"]);
			if ($str != "") {
				$entry["name"] = $str;
			}
		}
		if ($entry["name"] == "") {
			// If it got this far, spit out an e-mail address
			if (count($entry["emails"]) == 0) {
				$entry["name"] = "No Information";
			} else {
				$entry["name"] = $entry["emails"][0];
			}
		}
		return $entry;
	}

	// Sets the nickname for an entry by unique id
	// Returns true on success, false on failure
	function SetEntryNickname($entryid, $nickname) {
		// First check to see if they are the owner of this entry
		$rs = $this->_Query("SELECT id FROM entries WHERE userid=" . $this->userid . " AND id=" . (int)$entryid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$rs = $this->_Query("UPDATE entries SET nickname='" . addslashes($nickname) . "' WHERE id=" . (int)$entryid);
		if ($rs === false) {
			return false;
		} else {
			return true;
		}
	}

	// Takes the unique id of an entry and sets it's name
	// Returns true on success, false on failure
	function SetEntryName($entryid, $name) {
		// First check to see if they are the owner of this entry
		$rs = $this->_Query("SELECT id FROM entries WHERE userid=" . $this->userid . " AND id=" . (int)$entryid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$name = explode(" ", $name);
		$first = "";
		$middle = "";
		$last = "";
		$arr = array();
		if (count($name) > 0) {
			// Put the name in the correct order
			for ($i = count($name) - 1; $i >= 0; $i--) {
				if (strstr($name[$i], ",") == true) {
					array_push($arr, str_replace(",", "", $name[$i]));
				} else {
					array_unshift($arr, $name[$i]);
				}
			}
			$name = $arr;
			unset($arr);
			// Now figure out what is first, middle, and last
			$first = $name[0];
			if (count($name) == 2) {
				$last = $name[1];
			} else if (count($name) >= 3) {
				$last = $name[count($name) - 1];
				for ($i = 1; $i < count($name) - 1; $i++) {
					$middle .= $name[$i] . " ";
				}
				$middle = trim($middle);
			}
		}
		$rs = $this->_Query("UPDATE entries SET first='" . addslashes($first) . "', middle='" . $middle . "', last='" . $last . "' WHERE id=" . (int)$entryid);
		if ($rs === false) {
			return false;
		} else {
			return true;
		}
	}

	// Sets a setting to a value.
	// Returns true on success, false on failure
	// Example: SetSetting("autorefresh", 1)
	function SetSetting($setting, $value) {
		$this->_Query("BEGIN");
		@$this->_Query("DELETE FROM settings WHERE userid=" . $this->userid . " AND setting='" . addslashes($setting) . "'");
		$rs = $this->_Query("INSERT INTO settings (userid, setting, value) VALUES (" . $this->userid . ", '" . addslashes($setting) . "', '" . addslashes($value) . "')");
		if ($rs === false) {
			$this->_Query("ROLLBACK");
			return false;
		} else {
			$this->_Query("COMMIT");
			return true;
		}
	}

	// Adds an identity and calls it the first parameter ($name)
	// Returns the unique ID of the identity
	function AddIdentity($name) {
		$this->_Query("BEGIN");
		$rs = $this->_Query("INSERT INTO identities (userid, name) VALUES (" . $this->userid . ", '" . addslashes($name) . "')");
		if ($rs === false) {
			$this->_Query("ROLLBACK");
			return false;
		} else {
			$rs = $this->_Query("SELECT currval('identities_id_seq') as id");
			if ($rs === false) {
				$this->_Query("ROLLBACK");
				return false;
			} else {
				$this->_Query("COMMIT");
				$rs = pg_fetch_array($rs);
				return $rs["id"];
			}
		}
	}

	// Deletes an identity by it's unique id
	// Returns true on success, false on failure
	function DeleteIdentity($identityid) {
		// First check to see if they are our identity
		$rs = $this->_Query("SELECT id FROM identities WHERE userid=" . $this->userid . " AND id=" . (int)$identityid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$rs = $this->_Query("DELETE FROM identities WHERE id=" . $identityid);
		if ($rs === false) {
			return $false;
		} else {
			return true;
		}
	}

	// Sets the name of a particular identity given a unique ID and a name
	// Returns true on success, false on failure
	function SetIdentityName($identityid, $name) {
		// First check to see if they are our identity
		$rs = $this->_Query("SELECT id FROM identities WHERE userid=" . $this->userid . " AND id=" . (int)$identityid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$rs = $this->_Query("UPDATE identities SET name='" . addslashes($name) . "' WHERE id=" . (int)$identityid);
		if ($rs === false) {
			return false;
		} else {
			return true;
		}
	}

	// Sets the attribute for a particular identity
	// Example: SetIdentity(1, "displayname", "Jack Frost");
	// Returns true on success, false on failure
	function SetIdentityAttribute($identityid, $attribute, $value) {
		// First check to see if they are our identity
		$rs = $this->_Query("SELECT id FROM identities WHERE userid=" . $this->userid . " AND id=" . (int)$identityid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$rs = $this->_Query("UPDATE identities SET " . $attribute . "='" . addslashes($value) . "' WHERE id=" . (int)$identityid);
		if ($rs === false) {
			return false;
		} else {
			return true;
		}
	}

	// Changes the email address of a particular entry from an old address to a new address
	// Returns true on success, false on failure
	function ChangeEmail($entryid, $old, $new) {
		// check that such an entry exists
		$rs = $this->_Query("SELECT emails.id FROM entries, emails WHERE entries.userid=" . $this->userid . " AND entries.id=emails.entryid AND emails.email='" . addslashes($old) . "' LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$id = pg_fetch_array($rs);
		$rs = $this->_Query("UPDATE emails SET email='" . addslashes($new) . "' WHERE id=" . $id[0]["id"]);
		if ($rs === false) {
			return false;
		} else {
			return true;
		}
	}

	// Deletes an e-mail from a particular entry given a unique id and an address
	// Returns true on success, false on failure
	function DeleteEmail($entryid, $email) {
		// check that such an entry exists
		$rs = $this->_Query("SELECT emails.id FROM entries, emails WHERE entries.userid=" . $this->userid . " AND entries.id=emails.entryid AND emails.email='" . addslashes($email) . "' LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$id = pg_fetch_array($rs);
		$rs = $this->_Query("DELETE FROM emails WHERE id=" . $id["id"]);
		if ($rs === false) {
			return false;
		} else {
			return true;
		}
	}

	// Sets a particular address to default for a particular entry
	// Returns true on success, false on failure
	function SetDefaultEmail($entryid, $email) {
		// check that such an entry exists
		$rs = $this->_Query("SELECT emails.id FROM entries, emails WHERE entries.userid=" . $this->userid . " AND entries.id=emails.entryid AND emails.email='" . addslashes($email) . "' LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$id = pg_fetch_array($rs);
		$this->_Query("BEGIN");
		$rs = $this->_Query("UPDATE emails SET isdefault='f' WHERE entryid=" . (int)$entryid);
		if ($rs === false) {
			$this->_Query("ROLLBACK");
			return false;
		}
		$id = pg_fetch_array($rs);
		$rs = $this->_Query("UPDATE emails SET isdefault='t' WHERE id=" . $id["id"]);
		if ($rs === false) {
			$this->_Query("ROLLBACK");
			return false;
		} else {
			$this->_Query("COMMIT");
			return true;
		}
	}

	// Adds an e-mail address to an entry by unique id
	// Returns true on success, false on failure
	function AddEmailAddress($entryid, $email) {
		// First check to see if they are the owner of this entry
		$rs = $this->_Query("SELECT id FROM entries WHERE userid=" . $this->userid . " AND id=" . (int)$entryid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$id = pg_fetch_array($rs);
		$rs = $this->_Query("INSERT INTO emails (entryid, email) VALUES (" . $id["id"] . ", '" . addslashes($email) . "')");
		if ($rs === false) {
			return false;
		} else {
			return true;
		}
	}

	// Adds an entry given a string of information
	// Example: AddEntry("foo@bar.com");
	// Returns an associative array with status and id if successful
	function AddEntry($addressinfo) {
		// Seperate out the name from the e-mail address
		// Find an address - this is the simple way that does *some* validating - we can make this much much nastier if we have to
		preg_match_all("/([\w\.\-_]+@[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3})/", $addressinfo, $matches);
		if (count($matches[0]) == 0) {
			// There is no e-mail address, and we can't possibly add it. Foonutz.
			return array("code"=>0, "id"=>0);
		} else {
			$email = strtolower($matches[1][0]);
		}

		// Get the stuff in quotes if it is
		preg_match_all("/\"([^\"]+)\"/", $addressinfo, $matches);
		$name = str_replace("\"", "", $matches[1][0]);
		if ($name == "") {
			// there are no quotes, get the stuff anyway
			preg_match_all("/([^\s]+)/", $addressinfo, $matches);
			for ($i = 0; $i < count($matches[0]); $i++) {
				if (strstr($matches[0][$i], "@") == false) {
					$name[$i] = $matches[0][$i];
				}
			}
		} else {
			$name = split(" ", $name);
		}
		// Now we parse the name into what is likely first and last. If there is any.
		$first = "";
		$middle = "";
		$last = "";
		$arr = array();
		if (count($name) > 0) {
			// Put the name in the correct order
			for ($i = count($name) - 1; $i >= 0; $i--) {
				if (strstr($name[$i], ",") == true) {
					array_push($arr, str_replace(",", "", $name[$i]));
				} else {
					array_unshift($arr, $name[$i]);
				}
			}
			$name = $arr;
			unset($arr);
			// Now figure out what is first, middle, and last
			$first = $name[0];
			if (count($name) == 2) {
				$last = $name[1];
			} else if (count($name) >= 3) {
				$last = $name[count($name) - 1];
				for ($i = 1; $i < count($name) - 1; $i++) {
					$middle .= $name[$i] . " ";
				}
				$middle = trim($middle);
			}

		}
		// First, we shall see if this email address exists already
		$rs = $this->_Query("SELECT entries.id FROM emails, entries WHERE entries.id=emails.entryid AND entries.userid=" . $this->userid . " AND emails.email='" . addslashes($email) . "' LIMIT 1");
		if (pg_num_rows($rs) > 0) {
			// This e-mail address is already in the addressbook
			return array("code"=>2, "id"=>0);
		}

		// If the e-mail isn't there, and there exists some form of name, we'll use that.
		// The e-mail address was not found, maybe we should add it. Let's see if we have a place to add it.
		$rs = $this->_Query("SELECT id FROM entries WHERE first='" . addslashes($first) . "' AND middle='" . addslashes($middle) . "' AND last='" . addslashes($last) . "' LIMIT 1");
  		if ((pg_num_rows($rs) > 0) && (($first != "") || ($middle != "") || ($last != ""))){
			$id = pg_fetch_array($rs);
			$rs = $this->_Query("INSERT INTO emails (entryid, email) VALUES (" . $id["id"] . ", '" . addslashes($email) . "')");
			return array("code"=>1, "id"=>$id["id"]);
		} else {
			$this->_Query("BEGIN");
			$rs = $this->_Query("INSERT INTO entries (userid) VALUES (" . $this->userid . ")");
			if ($rs === false) {
				$this->_Query("ROLLBACK");
				return array("code"=>0, "id"=>0);
			}
			$rs = $this->_Query("SELECT currval('entries_id_seq') AS id");
			$rs = pg_fetch_array($rs);
			$id = $rs["id"];
			$rs = $this->_Query("INSERT INTO emails (entryid, email) VALUES (" . $rs["id"] . ", '" . addslashes($email) . "')");
			if ($rs === false) {
				$this->_Query("ROLLBACK");
				return array("code"=>0, "id"=>0);
			} else {
				$this->_Query("COMMIT");
				return array("code"=>1, "id"=>$id);
			}
		}
	}

	// Deletes an entry by unique ID
	// Returns true on success, false on failure
	function DeleteEntry($entryid) {
		// First check to see if they are the owner of this entry
		$rs = $this->_Query("SELECT id FROM entries WHERE userid=" . $this->userid . " AND id=" . (int)$entryid . " LIMIT 1");
		if (pg_num_rows($rs) != 1) {
			return false;
		}
		$this->_Query("BEGIN");
		$rs = $this->_Query("DELETE FROM emails WHERE entryid=" . (int)$entryid);
		if ($rs === false) {
			$this->_Query("ROLLBACK");
			return false;
		}
		$rs = $this->_Query("DELETE FROM entries WHERE id=" . (int)$entryid);
		if ($rs === false) {
			$this->_Query("ROLLBACK");
			return false;
		} else {
			$this->_Query("COMMIT");
			return true;
		}
	}

	// Toggles the sorting by various fields. If setting the field to what's already there, it should toggle the
	// direction
	// Accepts 'subject', 'from', and 'date'.
	// Returns true on success, false on failure
	function SetSorting($field) {
		if (($field == "subject") || ($field == "from") || ($field == "date")) {
			$rs = $this->_Query("SELECT value FROM settings WHERE setting='sortfield' AND userid=" . $this->userid);
			if ($rs === false) {
				return false;
			}
			if (pg_num_rows($rs) == 0) {
				if (!$this->SetSetting("sortfield", $field) || !$this->SetSetting("sortdirection", "asc")) {
					return false;
				} else {
					$_SESSION["sortfield"] = $field;
					$_SESSION["sortdirection"] = "asc";
					return true;
				}
			}
			$rs = pg_fetch_array($rs);
			if ($rs["value"] == $field) {
   				$rs = $this->_Query("SELECT value FROM settings WHERE userid=" . $this->userid . " AND setting='sortdirection' LIMIT 1");
				$rs = pg_fetch_array($rs);
				if ($rs["value"] == "asc") {
					$this->SetSetting("sortdirection", "desc");
					$_SESSION["sortdirection"] = "desc";
				} else {
					$this->SetSetting("sortdirection", "asc");
					$_SESSION["sortdirection"] = "asc";
				}
			} else {
				$this->SetSetting("sortfield", $field);
				$this->SetSetting("sortdirection", "desc");
				$_SESSION["sortfield"] = $field;
				$_SESSION["sortdirection"] = "desc";
			}
			return true;
		} else {
			return false;
		}
	}

	// Returns an array of the settings for the user
	function GetSettings() {
		while (list($key, $val) = each($GLOBALS["defaultsettings"])) {
			$setting = $this->_GetSetting($key);
			if ($setting !== false) {
				$settings[$key] = $setting;
			}
		}

		return $settings;
	}

	// Get an array of identities that has 'id', 'name', and 'isdefault'
	function GetIdentities() {
		$rs = $this->_Query("SELECT id, name, isdefault FROM identities WHERE userid=" . $this->userid . " ORDER BY name");
		if ($rs === false) {
			return false;
		} else {
			return $this->_FetchAll($rs);
		}
	}

	// Returns an associative array of all of the information of the identity attributes given the identity's unique id
	// Returns the array on success, false on failure
	function GetIdentityInfo($identityid) {
		$rs = $this->_Query("SELECT * FROM identities WHERE id=" . (int)$identityid . " AND userid=" . $this->userid);
		if ($rs === false) {
			return false;
		} else {
			$rs = pg_fetch_array($rs);
			return $rs;
		}
	}

	// Given a particular setting, it returns the value, or false if there isn't one
	function _GetSetting($setting) {
		$rs = $this->_Query("SELECT value FROM settings WHERE userid=" . $this->userid . " AND setting='" . addslashes($setting) . "' LIMIT 1");
		if ($rs === false) {
			trigger_error("Query to retrieve a setting failed", E_USER_ERROR);
		}
		if (pg_num_rows($rs) == 0) {
			// There is no row, so we must add it.
			if ($this->SetSetting($setting, $GLOBALS["defaultsettings"][$setting]["default"]) === false) {
				return false;
			} else {
				return $GLOBALS["defaultsettings"][$setting]["default"];
			}
		} else {
			$rs = pg_fetch_array($rs);
			return $rs["value"];
		}
	}

	// This is a wrapper which will handle old and new version of pgsql queries
	function _Query($query) {
		if (function_exists("pg_query")) {
			return pg_query($this->conn, $query);
		} else if (function_exists("pg_exec")) {
			return pg_exec($this->conn, $query);
		} else {
			trigger_error("No supported pgsql query function", E_USER_ERROR);
		}
	}

	// This is a wrapper which will handle old and new version of pgsql fetching all
	function _FetchAll($rs) {
		if (function_exists("pg_fetch_all")) {
			return pg_fetch_all($rs);
		} else if (function_exists("pg_fetch_array")) {
			$numrows = pg_num_rows($rs);
			for ($i = 0; $i < $numrows; $i++) {
				$row = pg_fetch_array($rs);
				$arr[$i] = $row;
			}
			return $arr;
		} else {
			trigger_error("No pgsql_fetch_all() or pgsql_fetch_array() functions");
		}
	}
}
?>
