<?PHP
	include "include/globals.php";
	include $_SESSION['addressbookstorage'];

	$AddressBook = new AddressBook();
	if (isset($_POST["updatesettings"])) {

		if (isset($_POST["locale"])) {
			UpdateLocale($_POST["locale"]);
		}
		$defsettings = array_keys($GLOBALS["defaultsettings"]);
		foreach ($defsettings as $defsetting){
			if ($GLOBALS["defaultsettings"][$defsetting]["type"] == "none") {
				continue;
			} else if ($GLOBALS["defaultsettings"][$defsetting]["type"] == "integer") {
				if (isset($_POST[$defsetting])) {
					$AddressBook->SetSetting($defsetting, (int)$_POST[$defsetting]);
					$_SESSION[$defsetting] = (int)$_POST[$defsetting];
				} else {
					$AddressBook->SetSetting($defsetting, (int)$GLOBALS["defaultsettings"][$defsetting]["value"]);
					$_SESSION[$defsetting] = (int)$GLOBALS["defaultsettings"][$defsetting]["value"];
				}
			} else if ($GLOBALS["defaultsettings"][$defsetting]["type"] == "boolean") {
				if (isset($_POST[$defsetting])) {
					$AddressBook->SetSetting($defsetting, 1);
					$_SESSION[$defsetting] = 1;
				} else {
					$AddressBook->SetSetting($defsetting, 0);
					$_SESSION[$defsetting] = 0;
				}
			} else if ($GLOBALS["defaultsettings"][$defsetting]["type"] == "select") {
				if (isset($_POST[$defsetting]) && (array_key_exists($_POST[$defsetting], $GLOBALS["defaultsettings"][$defsetting]["values"]))) {
					$AddressBook->SetSetting($defsetting, $_POST[$defsetting]);
					$_SESSION[$defsetting] = $_POST[$defsetting];
				} else {
					$AddressBook->SetSetting($defsetting, $GLOBALS["defaultsettings"][$defsetting]["value"]);
					$_SESSION[$defsetting] = $GLOBALS["defaultsettings"][$defsetting]["value"];
				}
			}
		}

		$updated = 1;
	}

	$settings = $AddressBook->GetSettings();

	PageHeader(1);
?>
<head>
	<title></title>
	<style type="text/css">
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/globals.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/settingsgeneral.css";
	</style>
	<script type="text/javascript">
		<!--
		parent.sheader.location.href = 'header.php?header=<?php echo(addslashes(gettext("General Settings")));?>';
		// -->
	</script>
</head>
<body>
<form id="settingform" method="post" action="settingsgeneral.php">
<table id="settingstable">
<?php
	if (isset($updated)) {
		echo("	<tr>\n");
		echo("		<td id=\"updatecell\" colspan=\"3\">\n");
		echo("			" . gettext("Your general settings have been updated") . "\n");
		echo("		</td>\n");
		echo("	</tr>\n");
	}

	reset($GLOBALS["defaultsettings"]);
	while (list($key, $val) = each($GLOBALS["defaultsettings"])) {
		if ($val["type"] == "none") {
			continue;
		}
		echo("	<tr>\n");
		echo("		<td class=\"lt\">\n");
		echo("			" . $val["desc"] . "\n");
		echo("		</td>\n");
		echo("		<td class=\"spc\">\n");
		echo("		</td>\n");
		echo("		<td class=\"rt\">\n");
		if ($val["type"] == "boolean") {
			echo("			<input type=\"checkbox\" name=\"" . $key . "\"");
			if ($settings[$key] == 1) {
				echo(" checked=\"checked\"");
			}
			echo("/>\n");
		} else if ($val["type"] == "integer") {
			echo("			<input size=\"5\" type=\"text\" name=\"" . $key . "\" value=\"" . (int)$settings[$key] . "\"/>\n");
		} else if ($val["type"] == "select") {
			echo("			<select name=\"" . $key . "\" size=\"1\">\n");
			while(list($valkey, $valval) = each($val["values"])) {
				echo("				<option value=\"" . htmlspecialchars($valkey) . "\"");
				if ($settings[$key] == $valkey) {
					echo(" selected=\"selected\"");
				}
				echo(">" . $valval . "</option>\n");
			}
			echo("			</select>\n");
		} else {
			echo("Can't change it yet - " . $val["type"]);
		}
		echo("		</td>\n");
		echo("	</tr>\n");
		echo("	<tr>\n");
		echo("		<td colspan=\"3\" class=\"separatorcell\">\n");
		echo("			<div class=\"separator\">\n");
		echo("				<br/>\n");
		echo("			</div>\n");
		echo("		</td>\n");
		echo("	</tr>\n");
	}
?>
	<tr>
		<td colspan="3" id="submitcell">
			<input type="submit" name="updatesettings" value=" <?php echo(gettext("Update Settings"));?> "/>
		</td>
	</tr>
</table>
</form>
</body>
</html>
