<?php
	include "include/globals.php";
	include "include/mailfunctions.php";

	$mbox = open_mailbox();

	function namehash($pos, $name) {
		return $pos . ":" . $name[0] . ":" . $name[strlen($name) - 1] . ":" . strlen($name);
	}

	if(isset($_REQUEST["update"])) {
		// ensure that they have an IMAP account on the system before creating a folder

		$folders = getfolderlist($mbox, 1);
		for ($i = 0; $i < count($folders); $i++) {
			if (isset($_REQUEST[namehash($i, $folders[$i]["name"])])) {
				imap_subscribe($mbox, $folders[$i]["folder"]);
			} else {
				imap_unsubscribe($mbox, $folders[$i]["folder"]);
			}
		}

		// close the window if we just created a folder and update the folder list
		echo("<html><head><script type=\"text/javascript\">\n");
		echo("	<!--\n");
		echo("	opener.parent.folderlist.document.location.href = 'folderlist.php';\n");
		echo("	window.close();\n");
		echo("	// -->\n");
		echo("</script></head><body></body></html>\n");
		exit;
	}

	PageHeader(1);
?>
<head>
	<title><?php echo(gettext("Subscribe/Unsubscribe"));?></title>
	<style type="text/css">
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/globals.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/xtree.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/folderlists.css";
	</style>
</head>
<body>
<form id="folderform" method="post" action="subscribe.php" onsubmit="return FillForm()">
	<div id="headercontainer">
		<div id="headerleftcap">
		</div>
		<div id="headerrightcap">
		</div>
		<div id="headerlabel">
			<?php echo(gettext("Subscribe/Unsubscribe"));?>
		</div>
	</div>
	<div id="folders">
		<div class="item"><img src="<?php echo("themes/" . $_SESSION["themedir"] . "/xtree/openfoldericon.png"); ?>" class="icon" alt=""/><a href="#n" class="subscribed">Inside Systems Mail</a></div>
	</div>
	<div id="submitinput">
		<input type="submit" value=" <?php echo(gettext("Update Subscriptions"));?> " name="update"/>
	</div>
</form>
<script type="text/javascript">
	<!--
	var f = new Array();
<?php
	// First get all of our subscribed folders in a hash, so we know they are subscribed
	$sfolders = getfolderlist($mbox);
	for ($i = 0; $i < count($sfolders); $i++) {
		$subscribedfolders[$sfolders[$i]["folder"]] = 1;
	}
	$folders = getfolderlist($mbox, 1);
	for ($i = 0; $i < count($folders); $i++) {
		echo("	f[" . $i . "] = new Object();\n");
		echo("	f[" . $i . "]['n'] = '" . addslashes($folders[$i]["name"]) . "';\n");
		echo("	f[" . $i . "]['l'] = " . $folders[$i]["level"] . ";\n");
		echo("	f[" . $i . "]['h'] = '" . namehash($i, $folders[$i]["name"]) . "';\n");
		if ($folders[$i]["folder"] == "") {
			echo("	f[" . $i . "]['s'] = -1;\n");
		} else {
			if (array_key_exists($folders[$i]["folder"], $subscribedfolders)) {
				echo("	f[" . $i . "]['s'] = 1;\n");
			} else {
				echo("	f[" . $i . "]['s'] = 0;\n");
			}
		}
	}
?>
	for (var i = 0; i < f.length; i++) {
		var newdiv = document.createElement('DIV');
		newdiv.className = 'item';
		var newimg = document.createElement('IMG');
		newimg.className = 'icon';
		newimg.style.marginLeft = (f[i]['l'] * 16) + 'px';
		if (f[i]['s'] == 1) {
			newimg.src = '<?php echo("themes/" . $_SESSION["themedir"] . "/xtree/openfoldericon.png"); ?>';
		} else {
			newimg.src = '<?php echo("themes/" . $_SESSION["themedir"] . "/xtree/foldericon.png"); ?>';
		}
		newdiv.appendChild(newimg);
		var newanchor = document.createElement('A');
		if (f[i]['s'] == 1) {
			newanchor.className = 'subscribed';
			newanchor.onclick = ToggleState;
		} else if (f[i]['s'] == 0) {
			newanchor.className = 'unsubscribed';
			newanchor.onclick = ToggleState;
		} else {
			newanchor.className = 'unsubscribed';
			newanchor.onclick = RootWarning;
		}
		newanchor.id = i;
		newanchor.appendChild(document.createTextNode(f[i]['n']));
		newdiv.appendChild(newanchor);
		document.getElementById('folders').appendChild(newdiv);
	}

	function ToggleState(e) {
		if (window.event) {
			var e_id = window.event.srcElement.id;
		} else {
			var e_id = e.target.id;
		}
		if (f[e_id]['s'] == 0) {
			document.getElementById(e_id).className = 'subscribed';
			document.getElementById(e_id).previousSibling.src = '<?php echo("themes/" . $_SESSION["themedir"] . "/xtree/openfoldericon.png"); ?>';
			f[e_id]['s'] = 1;
		} else {
			document.getElementById(e_id).className = 'unsubscribed';
			document.getElementById(e_id).previousSibling.src = '<?php echo("themes/" . $_SESSION["themedir"] . "/xtree/foldericon.png"); ?>';
			f[e_id]['s'] = 0;
		}
	}

	function RootWarning() {
		alert('<?php echo(addslashes(gettext("You cannot subscribe/unsubscribe to root folders in this IMAP flavor")));?>');
	}

	function FillForm() {
		for (i = 0; i < f.length; i++) {
			if (f[i]['s'] == 1) {
				var newhe = document.createElement('INPUT');
				newhe.type = 'hidden';
				newhe.name = f[i]['h'];
				newhe.value = 1;
				document.getElementById('folderform').appendChild(newhe);
			}
		}
		return true;
	}
	// -->
</script>
</body>
<?php
	imap_close($mbox);
?>
</html>
